--[[
BhaldieInfoBar v1.10.6.2
	
	BhaldieInfoBar: Displays information about different aspects of the game.

	- BhaldieInfobar (standard plugins).
		* IB_MINIDPS (by Shake)
		* Clock
		* Estimated time to level
		* Location
		* System Latency/FPS
		* Bag Status/ammo status
		* Monkey Speed (by Trentin)
		* PVP Honor
		* Money
]]
local binfobar_loaded = false;

function BhaldieInfoBar_Onload()	
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("UNIT_NAME_UPDATE");
	this:RegisterEvent("PLAYER_XP_UPDATE");
	this:RegisterEvent("PLAYER_LEVEL_UP");
	this:RegisterEvent("UPDATE_WORLD_STATES");
	this:RegisterEvent("TIME_PLAYED_MSG");
	this:RegisterEvent("UPDATE_GM_STATUS");
	this:RegisterEvent("UPDATE_FACTION");
	--this:RegisterEvent("UPDATE_FACTION");
	WoW_BuffFrame_Enchant_OnUpdate = BuffFrame_Enchant_OnUpdate;	
	BuffFrame_Enchant_OnUpdate = BM_BuffFrame_Enchant_OnUpdate;

	WoW_updateContainerFrameAnchors = updateContainerFrameAnchors;
	updateContainerFrameAnchors = BM_updateContainerFrameAnchors;
	--[[
	WoW_PetActionBarFrame_OnUpdate = PetActionBarFrame_OnUpdate;	
	PetActionBarFrame_OnUpdate = BM_PetActionBarFrame_OnUpdate;
	

	WoW_PetActionBar_UpdatePosition = PetActionBar_UpdatePosition;
	PetActionBar_UpdatePosition = BM_PetActionBar_UpdatePosition;

	WoW_ShapeshiftBar_UpdatePosition = ShapeshiftBar_UpdatePosition;
	ShapeshiftBar_UpdatePosition = BM_ShapeshiftBar_UpdatePosition;]]

end

function BiB_Plugin_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	-- ** New ** These lines load the plugins information
	this.timer = 0;
	PLUG_IN_FRAME = this:GetName();
	PLUG_IN_NAME = this.registry.menuText;
	if (getglobal(PLUG_IN_FRAME .. "Icon") and this.registry.iconWidth == nil) then
		BM_ICON_SIZE = 16;
	elseif (getglobal(PLUG_IN_FRAME .. "Icon") and this.registry.iconWidth) then
		BM_ICON_SIZE = this.registry.iconWidth;
	else
		BM_ICON_SIZE = 0;
	end
	
	BM_Plugin(PLUG_IN_FRAME, PLUG_IN_NAME,BM_ICON_SIZE, this.registry.id);
end

function BiB_Plugin_Initialize(buttonName, registry)
	-- Function to Initialize the saved vars if they don't exisit create them if they do exisits SWEET!!
	for key, value in registry.savedVariables do
		BM_Initialize_Variables(registry.id, key, value);
	end
	-- Creates the Dropdown menu
	UIDropDownMenu_Initialize(getglobal(buttonName .. "RightClickMenu"), getglobal("TitanPanelRightClickMenu_Prepare" .. registry.id .. "Menu"), "Menu"); 
	-- Initialize the icon
	if (registry.iconWidth ~= nil) then
		BiB_Plugin_SetIcon(buttonName, registry.id, registry.icon, registry.iconWidth);
	end
end

function BiB_Plugin_SetIcon(buttonName, id, iconName, iconWidth)
	if (iconWidth ~= nil) then
		local icon = tostring(buttonName) .. "Icon";
		if (TitanGetVar(id, "ShowIcon")) then
			getglobal(icon):SetTexture(iconName);
			getglobal(icon):SetWidth(iconWidth);
			getglobal(icon):SetHeight(iconWidth);
		else
			getglobal(icon):SetTexture("");
			getglobal(icon):SetWidth(1);
		end
	end
end

function BM_Plugin(PLUG_IN_FRAME, PLUG_IN_NAME, ICON_SIZE, PLUGIN_ID)
	TEMP_PLUGIN_TABLE[PLUG_IN_COUNT] = {
				id			= PLUGIN_ID,
				iconsize		= ICON_SIZE,
				enable		= DEFAULT_PLUGIN_ENABLE,
				framename	= PLUG_IN_FRAME,
				name		= PLUG_IN_NAME,
				position		= 1000 + PLUG_IN_COUNT,
			};
	PLUG_IN_COUNT = PLUG_IN_COUNT + 1;
end

function Refresh_Plugins()
	for key, value in BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"] do
		if (value.framename == "BM_Money") then
			BM_Gold:SetWidth(BM_GoldText:GetWidth() + value.iconsize);
			BM_Silver:SetWidth(BM_SilverText:GetWidth()+value.iconsize);
			BM_Copper:SetWidth(BM_CopperText:GetWidth()+value.iconsize);
			if (BM_Money:GetWidth() ~= BM_Gold:GetWidth()+BM_Silver:GetWidth()+BM_Copper:GetWidth()) then
				BM_Money:SetWidth(BM_Gold:GetWidth()+BM_Silver:GetWidth()+BM_Copper:GetWidth());
			end
		else
			local button = "TitanPanel".. value.id .. "Button";
			if (getglobal(button)) then
				if (getglobal(button).registry) then
					if (getglobal(button).registry.hasChild) then
						local childwidth = 0;
						local buttonText =  button.."Text";
						for childkey, childvalue in getglobal(button).registry.childButtonNames do
							if (getglobal(childvalue):IsVisible()) then
								childButton = getglobal(childvalue);
								childButtonText = childvalue .. "Text";
								childButtonIcon = childvalue .. "Icon";
								childButton:SetWidth(getglobal(childButtonText):GetWidth() + getglobal(childButtonIcon):GetWidth());
								childwidth =  childwidth + childButton:GetWidth();
							end
						end
						if (TitanGetVar(value.id, "ShowIcon")) then
							getglobal(button):SetWidth(getglobal(buttonText):GetWidth()+value.iconsize+childwidth);
						else
							getglobal(value.framename):SetWidth(getglobal(buttonText):GetWidth()+childwidth);
						end
					else
						if (TitanGetVar(value.id, "ShowIcon")) then
							getglobal(value.framename):SetWidth(getglobal(value.framename .. "Text"):GetWidth()+value.iconsize);
						else
							getglobal(value.framename):SetWidth(getglobal(value.framename .. "Text"):GetWidth());
						end	
					end
				else
					if (TitanGetVar(value.id, "ShowIcon")) then
						getglobal(value.framename):SetWidth(getglobal(value.framename .. "Text"):GetWidth()+value.iconsize);
					else
						getglobal(value.framename):SetWidth(getglobal(value.framename .. "Text"):GetWidth());
					end	
				end
			else
				if (TitanGetVar(value.id, "ShowIcon")) then
					getglobal(value.framename):SetWidth(getglobal(value.framename .. "Text"):GetWidth()+value.iconsize);
				else
					getglobal(value.framename):SetWidth(getglobal(value.framename .. "Text"):GetWidth());
				end	
			end
		end
	end
	BM_Update_Plugins();
end

function BM_Update_Plugins()		
	local new_row = false;
	local start_new_row = true;
	local total_row = 0;
	local plugin_offset = 0;
	local row_count = 1;
	BM_TOTAL_PLUGIN_WIDTH = 0;
	UI_PARENT_SCALE = UIParent:GetScale();
	UI_PARENT_WIDTH = UIParent:GetWidth()/UI_PARENT_SCALE;
	BG_WIDTH = UI_PARENT_WIDTH/4;
	BhaldieInfoBarBG1:SetWidth(BG_WIDTH);
	BhaldieInfoBarBG2:SetWidth(BG_WIDTH);
	BhaldieInfoBarBG3:SetWidth(BG_WIDTH);
	BhaldieInfoBarBG4:SetWidth(BG_WIDTH);
	BIB_Background:SetWidth(UI_PARENT_WIDTH-50+BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_xpscale);
	BhaldieCurrentXPBar:SetWidth(UI_PARENT_WIDTH-60+BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_xpscale);
	BhaldieRestXPBar:SetWidth(UI_PARENT_WIDTH-60+BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_xpscale);
	BhaldieInfoBarXPTexture:SetWidth(UI_PARENT_WIDTH-60+BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_xpscale);
	BhaldieInfoBar:SetWidth(UI_PARENT_WIDTH);
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].center_plugins) then
		BM_X_SPACER_TEXT = 0;
		BM_PLUGIN_ADD_ROW = 940/(1024/UI_PARENT_WIDTH);
	else
		BM_X_SPACER_TEXT = 70;
		BM_PLUGIN_ADD_ROW = 990/(1024/UI_PARENT_WIDTH);
	end
	if (BM_TOTAL_PLUGIN_WIDTH < BM_PLUGIN_ADD_ROW) then
		BhaldieInfoBarBG1:SetHeight(DEFAULT_INFO_BAR_HEIGHT+BM_INFO_XPBAR_OFFSET+BM_Y_SPACER_CHANGED);
		BhaldieInfoBarBG2:SetHeight(DEFAULT_INFO_BAR_HEIGHT+BM_INFO_XPBAR_OFFSET+BM_Y_SPACER_CHANGED);
		BhaldieInfoBarBG3:SetHeight(DEFAULT_INFO_BAR_HEIGHT+BM_INFO_XPBAR_OFFSET+BM_Y_SPACER_CHANGED);
		BhaldieInfoBarBG4:SetHeight(DEFAULT_INFO_BAR_HEIGHT+BM_INFO_XPBAR_OFFSET+BM_Y_SPACER_CHANGED);
		BIB_Background:SetHeight(DEFAULT_INFO_BAR_HEIGHT+BM_INFO_XPBAR_OFFSET+BM_Y_SPACER_CHANGED);
	end
	for i=1, PLUG_IN_COUNT-1, 1 do
		for j=1,  PLUG_IN_COUNT-1, 1 do
			if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].position == i) then 
				if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].enable == true) then
					local plugin_width;
					plugin_width = getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):GetWidth();
					BM_TOTAL_PLUGIN_WIDTH =  BM_TOTAL_PLUGIN_WIDTH + plugin_width + BM_X_SPACER_TEXT;
					if (new_row == false) then
						if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert == true) then
							BM_Y_SPACER_TEXT = (BM_PLUGIN_OFFSET_Y[row_count]+BM_INFO_XPBAR_OFFSET-5)+BM_Y_SPACER_CHANGED;
						else
							BM_Y_SPACER_TEXT = (BM_PLUGIN_OFFSET_Y[row_count]*-1-BM_INFO_XPBAR_OFFSET);
						end
						
					end
					if (BM_TOTAL_PLUGIN_WIDTH >= BM_PLUGIN_ADD_ROW) then
						start_new_row = true;
						if (start_new_row == true) then
							plugin_offset = 0;
							if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].center_plugins) then
								BM_X_SPACER_TEXT = 0;
							else
								BM_X_SPACER_TEXT = 70;
							end
							start_new_row = false;
							row_count = row_count + 1;
							if (row_count > BM_MAX_ROW_COUNT) then
								BM_MAX_ROW_COUNT = row_count
							end
							--BM_TOTAL_PLUGIN_WIDTH = 0;
							BM_TOTAL_PLUGIN_WIDTH =  plugin_width + BM_X_SPACER_TEXT;
						end
						if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert == true) then
							BM_Y_SPACER_TEXT = (DEFAULT_BM_PLUGIN_Y+BM_PLUGIN_OFFSET_Y[row_count]+BM_INFO_XPBAR_OFFSET-5)+BM_Y_SPACER_CHANGED;
						else
							BM_Y_SPACER_TEXT = ((DEFAULT_BM_PLUGIN_Y+BM_PLUGIN_OFFSET_Y[row_count]+BM_INFO_XPBAR_OFFSET))*-1;
						end
						BhaldieInfoBarBG1:SetHeight((DEFAULT_INFO_BAR_HEIGHT+(BM_INFO_HEIGHT_OFFSET[row_count])+BM_INFO_XPBAR_OFFSET)+BM_Y_SPACER_CHANGED);
						BhaldieInfoBarBG2:SetHeight((DEFAULT_INFO_BAR_HEIGHT+(BM_INFO_HEIGHT_OFFSET[row_count])+BM_INFO_XPBAR_OFFSET)+BM_Y_SPACER_CHANGED);
						BhaldieInfoBarBG3:SetHeight((DEFAULT_INFO_BAR_HEIGHT+(BM_INFO_HEIGHT_OFFSET[row_count])+BM_INFO_XPBAR_OFFSET)+BM_Y_SPACER_CHANGED);
						BhaldieInfoBarBG4:SetHeight((DEFAULT_INFO_BAR_HEIGHT+(BM_INFO_HEIGHT_OFFSET[row_count])+BM_INFO_XPBAR_OFFSET)+BM_Y_SPACER_CHANGED);
						BIB_Background:SetHeight((DEFAULT_INFO_BAR_HEIGHT+(BM_INFO_HEIGHT_OFFSET[row_count])+BM_INFO_XPBAR_OFFSET)+BM_Y_SPACER_CHANGED);
						new_row = true;
					end
					if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].center_plugins ) then
							if (row_count == 1) then
								getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):ClearAllPoints();
								getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):SetPoint("LEFT", "BIB_PluginFrame1", "LEFT", plugin_offset + BM_X_SPACER_TEXT,BM_Y_SPACER_TEXT);
								BIB_PluginFrame1:SetWidth(plugin_width + BM_X_SPACER_TEXT+plugin_offset);
							elseif (row_count == 2) then
								getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):ClearAllPoints();
								getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):SetPoint("LEFT", "BIB_PluginFrame2", "LEFT", plugin_offset + BM_X_SPACER_TEXT,BM_Y_SPACER_TEXT);
								BIB_PluginFrame2:SetWidth(plugin_width + BM_X_SPACER_TEXT+plugin_offset);
							elseif (row_count == 3) then
								getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):ClearAllPoints();
								getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):SetPoint("LEFT", "BIB_PluginFrame3", "LEFT", plugin_offset + BM_X_SPACER_TEXT,BM_Y_SPACER_TEXT);
								BIB_PluginFrame3:SetWidth(plugin_width + BM_X_SPACER_TEXT+plugin_offset);
							elseif (row_count == 4) then
								getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):ClearAllPoints();
								getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):SetPoint("LEFT", "BIB_PluginFrame4", "LEFT", plugin_offset + BM_X_SPACER_TEXT,BM_Y_SPACER_TEXT);
								BIB_PluginFrame4:SetWidth(plugin_width + BM_X_SPACER_TEXT+plugin_offset);
							elseif (row_count == 5) then
								getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):ClearAllPoints();
								getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):SetPoint("LEFT", "BIB_PluginFrame5", "LEFT", plugin_offset + BM_X_SPACER_TEXT,BM_Y_SPACER_TEXT);
								BIB_PluginFrame5:SetWidth(plugin_width + BM_X_SPACER_TEXT+plugin_offset);
							elseif (row_count == 6) then
								getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):ClearAllPoints();
								getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):SetPoint("LEFT", "BIB_PluginFrame6", "LEFT", plugin_offset + BM_X_SPACER_TEXT,BM_Y_SPACER_TEXT);
								BIB_PluginFrame6:SetWidth(plugin_width + BM_X_SPACER_TEXT+plugin_offset);
							end
					else
						if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert == true) then
							getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):ClearAllPoints();
							getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):SetPoint("BOTTOMLEFT", "BhaldieInfoBar", "BOTTOMLEFT", plugin_offset  + BM_X_SPACER_TEXT, (BM_Y_SPACER_TEXT-8));
						else
							getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):ClearAllPoints();
							getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):SetPoint("TOPLEFT", "BhaldieInfoBar", "TOPLEFT", plugin_offset  + BM_X_SPACER_TEXT, (BM_Y_SPACER_TEXT+8));
						end
						
					end
					plugin_offset =  plugin_offset + plugin_width + BM_X_SPACER_TEXT;
					BM_X_SPACER_TEXT = 30 + BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_xspace;
					getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):Show();
				else
					getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):ClearAllPoints();
					getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):SetPoint("TOP", "UIParent", "TOP", 0, 100);
					getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][j].framename):Hide();
				end
			end
		end
	end
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert == true) then
		BhaldieInfoBar:SetHeight(BhaldieInfoBarBG1:GetHeight()-10);
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].autohide == true  and not MouseIsOver(BhaldieInfoBar)) then
			BhaldieInfoBar:ClearAllPoints();
			BhaldieInfoBar:SetPoint("BOTTOMLEFT", "UIParent", "BOTTOMLEFT", 0, (BhaldieInfoBarBG1:GetHeight()-20)*-1);
		else
			BhaldieInfoBar:ClearAllPoints();
			BhaldieInfoBar:SetPoint("BOTTOMLEFT", "UIParent", "BOTTOMLEFT",  0, 0);
		end
	else
		BhaldieInfoBar:SetHeight(BhaldieInfoBarBG1:GetHeight()-10);
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].autohide == true and not MouseIsOver(BhaldieInfoBar)) then
			BhaldieInfoBar:ClearAllPoints();
			--BhaldieInfoBar:SetPoint("TOPLEFT", "UIParent", "TOPLEFT",  -10, 8);
			BhaldieInfoBar:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", -10, BhaldieInfoBarBG1:GetHeight()-20);
		else
			BhaldieInfoBar:ClearAllPoints();
			BhaldieInfoBar:SetPoint("TOPLEFT", "UIParent", "TOPLEFT",  -10, 8);
		end	
	end
end

function BhaldieInfoBar_OnEvent(event)
	if (event == "VARIABLES_LOADED"  or event == "PLAYER_ENTERING_WORLD" or event == "UNIT_NAME_UPDATE") then		
		BhaldieInfoBar_initialize();
	end
	if (event == "PLAYER_ENTERING_WORLD") then
		RequestTimePlayed();
		--BIB_CheckXPBar();
	end
	if (event == "PLAYER_XP_UPDATE" or event == "PLAYER_LEVEL_UP" or event == "PLAYER_ENTERING_WORLD" or event == "UNIT_NAME_UPDATE" or event == "VARIABLES_LOADED") then
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].showrepbar == false or not ReputationWatchBar:IsShown()) then
			-- Creates xp bars for infobar
			BhaldieCurrXP = UnitXP("player");
			BhaldieMaxXP = UnitXPMax("player");
			BhaldieRestXP = GetXPExhaustion();
			BhaldieCurrentXPBar:SetMinMaxValues(0, BhaldieMaxXP);
			BhaldieRestXPBar:SetMinMaxValues(0, BhaldieMaxXP);
			BhaldieCurrentXPBar:SetValue(BhaldieCurrXP);
			if (BhaldieRestXP ~= nil and BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_hidexp == true) then
				BhaldieRestXPBar:Show();
				BhaldieRestXPBar:SetValue(BhaldieCurrXP + BhaldieRestXP);
				BhaldieCurrentXPBar:SetStatusBarColor(0.22, 0.39, 1.0, 1.0);
				BhaldieRestXPBar:SetStatusBarColor(0.0, 1.0, 0.39, 0.60);
				--BhaldieRestXPBar:SetStatusBarColor(0.0, 0.54, 0.57, 0.75);
			else 
				BhaldieRestXP = 0;
				BhaldieRestXPBar:Hide();
				BhaldieCurrentXPBar:SetStatusBarColor(0.58, 0.0, 0.55, 1.0);
			end
			BhaldieInfoBarXPText:SetText(format(XP_TEXT_WHITE, BhaldieCurrXP, BhaldieMaxXP, BhaldieRestXP));
			return;
		end
	end
	
	if(event == "UPDATE_WORLD_STATES") then
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert == false) then
			WorldStateAlwaysUpFrame:ClearAllPoints();
			WorldStateAlwaysUpFrame:SetPoint("TOP", "BhaldieInfoBarBG2", "BOTTOMRIGHT", -10, -10);
		end
	end

	if (event == "TIME_PLAYED_MSG") then
		BM_TOTAL_TIME = arg1;
		BM_TOTAL_TIME_FOR_LEVEL = arg2;
	end
	
	if (event == "UPDATE_GM_STATUS") then
		if ( arg1 ~= 0 ) then		
			this:Show();
			TemporaryEnchantFrame:SetPoint("TOPRIGHT", this:GetParent(), "TOPRIGHT", -205, (-this:GetHeight()));
			refreshTime = GMTICKET_CHECK_INTERVAL;
		else
			this:Hide();
			TemporaryEnchantFrame:SetPoint("TOPRIGHT", "UIParent", "TOPRIGHT", -180, -13);
		end
	end

	if (event == "UPDATE_FACTION") then
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].showrepbar) then
			local name, reaction, min, max, value = GetWatchedFactionInfo();
			if (name) then
				-- Normalize values
				max = max - min;
				value = value - min;
				min = 0;
				BhaldieCurrentXPBar:SetMinMaxValues(min, max);
				BhaldieCurrentXPBar:SetValue(value);
				BhaldieInfoBarXPText:SetText(name.." "..value.." / "..max);
				local color = FACTION_BAR_COLORS[reaction];
				BhaldieCurrentXPBar:SetStatusBarColor(color.r, color.g, color.b);
				BhaldieRestXPBar:Hide();
			else
				-- Creates xp bars for infobar
				BhaldieCurrXP = UnitXP("player");
				BhaldieMaxXP = UnitXPMax("player");
				BhaldieRestXP = GetXPExhaustion();
				BhaldieCurrentXPBar:SetMinMaxValues(0, BhaldieMaxXP);
				BhaldieRestXPBar:SetMinMaxValues(0, BhaldieMaxXP);
				BhaldieCurrentXPBar:SetValue(BhaldieCurrXP);
				if (BhaldieRestXP ~= nil and BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_hidexp == true) then
					BhaldieRestXPBar:Show();
					BhaldieRestXPBar:SetValue(BhaldieCurrXP + BhaldieRestXP);
					BhaldieCurrentXPBar:SetStatusBarColor(0.22, 0.39, 1.0, 1.0);
					BhaldieRestXPBar:SetStatusBarColor(0.0, 1.0, 0.39, 0.60);
					--BhaldieRestXPBar:SetStatusBarColor(0.0, 0.54, 0.57, 0.75);
				else 
					BhaldieRestXP = 0;
					BhaldieRestXPBar:Hide();
					BhaldieCurrentXPBar:SetStatusBarColor(0.58, 0.0, 0.55, 1.0);
				end
				BhaldieInfoBarXPText:SetText(format(XP_TEXT_WHITE, BhaldieCurrXP, BhaldieMaxXP, BhaldieRestXP));
			end
		end
	end
end

function BhaldieInfoBar_initialize()
	local table_count;
	local temp_table_count;
	if (binfobar_loaded == false) then
		binfobar_loaded = true;
		BM_PLAYERNAME_REALM = GetCVar("realmName") .. "|" .. UnitName("player");
		--Make sure BHINFOBAR_CONFIG is ready
		if (not BHINFOBAR_CONFIG) then
			BHINFOBAR_CONFIG = { };
		end
		-- Check if there's not an entry for this player
		if (not BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM] = {};
		end
		if (not BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"]) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"] = {};
		end
		if (not BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["PluginsVars"]) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["PluginsVars"] = {};
		end
		if (not BHINFOBAR_CONFIG["Profiles"]) then
			BHINFOBAR_CONFIG["Profiles"] = {};
		end

		
		
		temp_table_count = table.getn(TEMP_PLUGIN_TABLE);
		if (temp_table_count > 0) then
			for temp_key, temp_value in TEMP_PLUGIN_TABLE do
				for saved_key, saved_value in BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"] do
					if (temp_value.framename == saved_value.framename) then
						temp_value.position = saved_value.position;
						temp_value.enable = saved_value.enable;
					end
				end
			end
			table.sort (TEMP_PLUGIN_TABLE, function (v1, v2) return v1.position < v2.position end)
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"] = {};	
			for temp_key, temp_value in TEMP_PLUGIN_TABLE do
				BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][temp_key] = {};
				BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][temp_key] = {
							id			= temp_value.id,
							iconsize		= temp_value.iconsize,
							enable		= temp_value.enable,
							position		= temp_key,
							framename	= temp_value.framename,
							name		= temp_value.name,
						};
			end
		else
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"] = {};	
		end
				
		-- BhaldieInfoBar Options
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_enable == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_enable = DEFAULT_BM_INFO_ENABLE;
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_alpha == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_alpha = DEFAULT_BM_INFO_ALPHA;
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].xp_info == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].xp_info = DEFAULT_BM_XP_INFO_FRAME;
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_xpscale == nil or BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_xpscale > 60) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_xpscale = DEFAULT_BM_XPBAR_SCALE;
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_xspace == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_xspace = DEFAULT_BM_PLUGIN_XSCALE;
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize = DEFAULT_BM_PLUGIN_FONTSIZE;
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert = DEFAULT_BM_INFOBAR_INVERT;
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_hidexp == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_hidexp = DEFAULT_BM_INFOBAR_HIDEXP;
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_hidelogo == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_hidelogo = true;
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].center_plugins == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].center_plugins = false;
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType = "Interface\\AddOns\\BhaldieInfoBar\\fonts\\framd.ttf";
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontCode == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontCode = "BIB_Default";
		end
		--[[if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].mainmenu_xp == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].mainmenu_xp = false;
		end]]
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].height_offset == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].height_offset = 0;
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].autohide == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].autohide = false;
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_hidelogo == true) then
			BhaldieInfoBarLogoFrame:SetAlpha(100);
		else
			BhaldieInfoBarLogoFrame:SetAlpha(0);
		end
		if (BHINFOBAR_CONFIG.bib_debug == nil) then
			BHINFOBAR_CONFIG.bib_debug = "false";
		end
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].showrepbar == nil) then
			BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].showrepbar = false;
		end
		
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert == true) then
			--BhaldieInfoBar:ClearAllPoints();
			--BhaldieInfoBar:SetPoint("BOTTOMLEFT", "UIParent", "BOTTOMLEFT", 0, 0);
			BhaldieInfoBarBG1:ClearAllPoints();
			BhaldieInfoBarBG1:SetPoint("BOTTOMLEFT", "BhaldieInfoBar", "BOTTOMLEFT", 0, -24);
			--[[
			BhaldieInfoBarBG1:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background2_bar1");
			BhaldieInfoBarBG2:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background2_bar2");
			BhaldieInfoBarBG3:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background2_bar3");
			BhaldieInfoBarBG4:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background2_bar4");
			]]
			BIB_Background:ClearAllPoints();
			BIB_Background:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, -20);
			BIB_PluginFrame1:ClearAllPoints();
			BIB_PluginFrame1:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 0);
			BIB_PluginFrame2:ClearAllPoints();
			BIB_PluginFrame2:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 0);
			BIB_PluginFrame3:ClearAllPoints();
			BIB_PluginFrame3:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 0);
			BIB_PluginFrame4:ClearAllPoints();
			BIB_PluginFrame4:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 0);
			BIB_PluginFrame5:ClearAllPoints();
			BIB_PluginFrame5:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 0);
			BIB_PluginFrame6:ClearAllPoints();
			BIB_PluginFrame6:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 0);
			BhaldieInfoBarLogoFrame:ClearAllPoints();
			BhaldieInfoBarLogoFrame:SetPoint("CENTER", "BIB_Background", "TOPLEFT", 15, -8);
			BhaldieCurrentXPBar:ClearAllPoints();
			BhaldieCurrentXPBar:SetPoint("BOTTOM", "BhaldieInfoBar", "BOTTOM", 0, 5);
			BhaldieInfoBar:Show();
			-- Moves the minimap, player, party, pet, and target frames down to allow the info bar to be placed.
			MinimapCluster:ClearAllPoints();
			MinimapCluster:SetPoint("TOPRIGHT", "UIParent", "TOPRIGHT", 0, 0);
			TicketStatusFrame:ClearAllPoints();
			TicketStatusFrame:SetPoint("TOPRIGHT", "UIParent", "TOPRIGHT", -180, 0);
			if (not IsAddOnLoaded("DiscordActionBars") and not IsAddOnLoaded("Nurfed_ActionBars")) then
				MainMenuBar:ClearAllPoints();
				MainMenuBar:SetPoint("BOTTOM", "BhaldieInfoBarBG2", "TOPRIGHT", 0, 0);
			end
			if (not IsAddOnLoaded("CT_UnitFrames") and not IsAddOnLoaded("Gypsy_UnitBars")  and not IsAddOnLoaded("DiscordUnitFrames")) then
				PlayerFrame:ClearAllPoints();
				PlayerFrame:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", -19, -4);
				PartyMemberFrame1:ClearAllPoints();
				PartyMemberFrame1:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 10, -128);
				TargetFrame:ClearAllPoints();
				TargetFrame:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 250, -4);

			end
			BM_TOOLTIP_ANCHOR = "BOTTOM";
			BM_TOOLTIP_RELPOINT = "TOP";
		else
			--BhaldieInfoBar:ClearAllPoints();
			--BhaldieInfoBar:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", -10, 8);
			BhaldieInfoBarBG1:ClearAllPoints();
			BhaldieInfoBarBG1:SetPoint("TOPLEFT", "BhaldieInfoBar", "TOPLEFT", 0, 18);
			--[[
			BhaldieInfoBarBG1:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background_bar1");
			BhaldieInfoBarBG2:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background_bar2");
			BhaldieInfoBarBG3:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background_bar3");
			BhaldieInfoBarBG4:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\Background_bar4");
			]]
			BIB_Background:ClearAllPoints();
			BIB_Background:SetPoint("TOP", "BhaldieInfoBar", "TOP", 10, 14);
			BIB_PluginFrame1:ClearAllPoints();
			BIB_PluginFrame1:SetPoint("TOP", "BhaldieInfoBar", "TOP", 0, 0);
			BIB_PluginFrame2:ClearAllPoints();
			BIB_PluginFrame2:SetPoint("TOP", "BhaldieInfoBar", "TOP", 0, 0);
			BIB_PluginFrame3:ClearAllPoints();
			BIB_PluginFrame3:SetPoint("TOP", "BhaldieInfoBar", "TOP", 0, 0);
			BIB_PluginFrame4:ClearAllPoints();
			BIB_PluginFrame4:SetPoint("TOP", "BhaldieInfoBar", "TOP", 0, 0);
			BIB_PluginFrame5:ClearAllPoints();
			BIB_PluginFrame5:SetPoint("TOP", "BhaldieInfoBar", "TOP", 0, 0);
			BIB_PluginFrame6:ClearAllPoints();
			BIB_PluginFrame6:SetPoint("TOP", "BhaldieInfoBar", "TOP", 0, 0);
			--BhaldieInfoBarLogoFrame:ClearAllPoints();
			--BhaldieInfoBarLogoFrame:SetPoint("TOPLEFT", "BhaldieInfoBar", "TOPLEFT", 16, -2);
			BhaldieInfoBarLogoFrame:ClearAllPoints();
			BhaldieInfoBarLogoFrame:SetPoint("CENTER", "BIB_Background", "BOTTOMLEFT", 13, 8);
			BhaldieCurrentXPBar:ClearAllPoints();
			BhaldieCurrentXPBar:SetPoint("TOP", "BhaldieInfoBar", "TOP", 10, -8);
			BhaldieInfoBar:Show();
			-- Moves the minimap, player, party, pet, and target frames down to allow the info bar to be placed.
			MinimapCluster:ClearAllPoints();
			MinimapCluster:SetPoint("TOPRIGHT", "BhaldieInfoBarBG4", "BOTTOMRIGHT", 10, -10);
			TicketStatusFrame:ClearAllPoints();
			TicketStatusFrame:SetPoint("TOPRIGHT", "BhaldieInfoBarBG4", "BOTTOMRIGHT", -180, 0);
			if (not IsAddOnLoaded("DiscordActionBars") and not IsAddOnLoaded("Nurfed_ActionBars")) then
				MainMenuBar:ClearAllPoints();
				MainMenuBar:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, 0);
			end
			if (not IsAddOnLoaded("CT_UnitFrames") and not IsAddOnLoaded("Gypsy_UnitBars")  and not IsAddOnLoaded("DiscordUnitFrames")) then
				PlayerFrame:ClearAllPoints();
				PlayerFrame:SetPoint("TOPLEFT", "BhaldieInfoBarBG1", "BOTTOMLEFT", -19, -14);
				PartyMemberFrame1:ClearAllPoints();
				PartyMemberFrame1:SetPoint("TOPLEFT", "BhaldieInfoBarBG1", "BOTTOMLEFT", 10, -138);
				TargetFrame:ClearAllPoints();
				TargetFrame:SetPoint("TOPLEFT", "BhaldieInfoBarBG1", "BOTTOMLEFT", 250, -14);
			end
			BM_TOOLTIP_ANCHOR = "TOP";
			BM_TOOLTIP_RELPOINT = "BOTTOM";
		end			
			
		
		-- BhalideInfoBar BG graphics
		BIB_Background:SetAlpha(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_alpha);
		--[[
		BhaldieInfoBarBG1:SetAlpha(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_alpha);
		BhaldieInfoBarBG2:SetAlpha(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_alpha);
		BhaldieInfoBarBG3:SetAlpha(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_alpha);
		BhaldieInfoBarBG4:SetAlpha(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_alpha);
		]]
			
		--Font Size and Type
		table_count = table.getn(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"]);
		if (table_count > 0) then
			local uiscale = 1;
			for key, value in BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"] do
			--for i=1, table_count, 1 do
				if (value.framename == "BM_Money") then
					BM_Gold:SetTextFontObject(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontCode);
					BM_GoldText:SetTextHeight(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
					BM_Gold:SetScale(2);
					BM_Gold:SetScale(uiscale);
					--BM_Gold:SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
					BM_Silver:SetTextFontObject(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontCode);
					BM_SilverText:SetTextHeight(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
					BM_Silver:SetScale(2);
					BM_Silver:SetScale(uiscale);
					--BM_Silver:SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
					BM_Copper:SetTextFontObject(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontCode);
					BM_CopperText:SetTextHeight(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
					BM_Copper:SetScale(2);
					BM_Copper:SetScale(uiscale);
					--BM_Copper:SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
				else
					local button = "TitanPanel".. value.id .. "Button";
					if (getglobal(button)) then
						if (getglobal(button).registry) then
							if (getglobal(button).registry.hasChild) then
								for childkey, childvalue in getglobal(button).registry.childButtonNames do
									getglobal(childvalue):SetTextFontObject(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontCode);
									getglobal(childvalue .. "Text"):SetTextHeight(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
									getglobal(childvalue):SetScale(2);
									getglobal(childvalue):SetScale(uiscale);
									--getglobal(childvalue):SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
									--bib_debug(childvalue);
								end
								getglobal(value.framename):SetTextFontObject(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontCode);
								getglobal(value.framename .. "Text"):SetTextHeight(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
								getglobal(value.framename):SetScale(2);
								getglobal(value.framename):SetScale(uiscale);
								--getglobal(value.framename):SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
							else
								getglobal(value.framename):SetTextFontObject(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontCode);
								getglobal(value.framename .. "Text"):SetTextHeight(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
								getglobal(value.framename):SetScale(2);
								getglobal(value.framename):SetScale(uiscale);
								--getglobal(value.framename):SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
							end
						else
							getglobal(value.framename):SetTextFontObject(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontCode);
							getglobal(value.framename .. "Text"):SetTextHeight(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
							getglobal(value.framename):SetScale(2);
							getglobal(value.framename):SetScale(uiscale);
							--getglobal(value.framename):SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
						end
					else
						getglobal(value.framename):SetTextFontObject(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontCode);
						getglobal(value.framename .. "Text"):SetTextHeight(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
						getglobal(value.framename):SetScale(2);
						getglobal(value.framename):SetScale(uiscale);
						--getglobal(value.framename):SetFont(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].fontType, BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].plugin_fontsize);
					end
				end
			end
		end

		if (DEFAULT_CHAT_FRAME) then
			DEFAULT_CHAT_FRAME:AddMessage(BHALDIEINFOBAR_LOADED);			
			UIErrorsFrame:AddMessage(BHALDIEINFOBAR_LOADED, 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
		end

		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].xp_info == true) then
			BhaldieInfoBarXPText:Show();
		else
			BhaldieInfoBarXPText:Hide();
		end

		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_hidexp == true) then
			BhaldieCurrentXPBar:Show();
			BhaldieRestXPBar:Show();
			BM_INFO_XPBAR_OFFSET = -4;
		else
			BhaldieCurrentXPBar:Hide();
			BhaldieRestXPBar:Hide();
			BM_INFO_XPBAR_OFFSET = -15;
		end
		BM_Update_Plugins();
	end
	-- XP Bar Scale
	BhaldieCurrentXPBar:SetWidth(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_xpscale);
	BhaldieRestXPBar:SetWidth(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_xpscale);
	BhaldieInfoBarXPTexture:SetWidth(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_xpscale);
	BhaldieInfoBarXPTexture:SetHeight(12);
end


-- Loads all the moveable bars.
function BhaldieInfoBar_OnUpdate(arg1)	
	--BM_Weapon_Frame_Refresh();
	--bib_debug(GetMouseFocus():GetName());
	BHALDIEINFOBAR_REFRESH = BHALDIEINFOBAR_REFRESH + arg1;
	if (BHALDIEINFOBAR_REFRESH > BHALDIEINFOBAR_DELAY and BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert == false) then
		Refresh_Plugins();
		BHALDIEINFOBAR_REFRESH = 0.0;
		TemporaryEnchantFrame:ClearAllPoints();
		if (TicketStatusFrame:IsVisible()) then
			TemporaryEnchantFrame:SetPoint("TOPRIGHT", "BhaldieInfoBarBG4", "BOTTOMRIGHT", -175, -TicketStatusFrame:GetHeight());
		else
			TemporaryEnchantFrame:SetPoint("TOPRIGHT", "BhaldieInfoBarBG4", "BOTTOMRIGHT", -175, -13);
		end
		--TemporaryEnchantFrame:SetPoint("TOPRIGHT", "UIParent", "TOPRIGHT", -175, -13+BM_UNIT_BUFF_FRAMES_Y);
	elseif (BHALDIEINFOBAR_REFRESH > BHALDIEINFOBAR_DELAY and BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert == true) then
		Refresh_Plugins();
		BHALDIEINFOBAR_REFRESH = 0.0;
		TemporaryEnchantFrame:ClearAllPoints();
		if (TicketStatusFrame:IsVisible()) then
			TemporaryEnchantFrame:SetPoint("TOPRIGHT", "UIParent", "TOPRIGHT", -175, -TicketStatusFrame:GetHeight());
		else
			TemporaryEnchantFrame:SetPoint("TOPRIGHT", "UIParent", "TOPRIGHT", -175, -13);
		end
	end
end

-- Tooltip functions
function InfoBarLogo_OnEnter()
	GameTooltip:SetOwner(this, "ANCHOR_NONE");
	GameTooltip:SetPoint(BM_TOOLTIP_ANCHOR .. BM_PositonToolTip_RightLeft(), this, BM_TOOLTIP_RELPOINT .. BM_PositonToolTip_RightLeft(), 0, 0);
	GameTooltip:SetText(BHALDIE_LOGO_TOOLTIP_TITLE);
	BM_Tooltip_AddTooltipText(BHALDIE_LOGO_TOOLTIP_TEXT);
	--GameTooltip:AddLine(BHALDIE_LOGO_TOOLTIP_TEXT);
	GameTooltip:Show();
end

function InfoBarLogo_OnLeave()
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip:Hide();
end

-- Tooltip functions
function BM_Rest_OnEnter()
	GameTooltip:SetOwner(this, "ANCHOR_NONE");
	GameTooltip:SetPoint("BOTTOMLEFT", BM_ResetAllButton, "TOPRIGHT", 0, 0);
	GameTooltip:SetText(BM_INFOBAR_REST_TOOLTIP_TITLE);
	GameTooltip:AddLine(BM_INFOBAR_REST_TOOLTIP);
	GameTooltip:Show();
end

function BM_Rest_OnLeave()
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip:Hide();
end

function BM_PositonToolTip_RightLeft()
	if (this:GetRight() >= (UI_PARENT_WIDTH/2)) then
		BM_TOOLTIP_RIGHTLEFT = "RIGHT";
	else
		BM_TOOLTIP_RIGHTLEFT = "LEFT";
	end
	return BM_TOOLTIP_RIGHTLEFT;
end

function BM_Tooltip_AddTooltipText(text)
	if ( text ) then
		-- Append a "\n" to the end 
		if ( string.sub(text, -1, -1) ~= "\n" ) then
			text = text.."\n";
		end
		
		for text1, text2 in string.gfind(text, "([^\t\n]*)\t?([^\t\n]*)\n") do
			--DEFAULT_CHAT_FRAME:AddMessage(text1);
			if ( text2 ~= "" ) then
				GameTooltip:AddDoubleLine(text1, text2);
			elseif ( text1 ~= "" ) then
				GameTooltip:AddLine(text1);
			else
				GameTooltip:AddLine("\n");
			end			
		end
	end
end

function BM_GetTime(time)
	local days = floor(time/24/60/60); time = mod(time, 24*60*60);
	local hours = floor(time/60/60); time = mod(time, 60*60);
	local minutes = floor(time/60); time = mod(time, 60);
	local seconds = time;

	local timeText = "";
	if (days ~= 0) then
		timeText = timeText..format("%d"..BM_DAYS.." ", days);
	end
	if (days ~= 0 or hours ~= 0) then
		timeText = timeText..format("%d"..BM_HOURS.." ", hours);
	end
	if (days ~= 0 or hours ~= 0 or minutes ~= 0) then
		timeText = timeText..format("%d"..BM_MINUTES.." ", minutes);
	end	
	if (days ~= 0 or hours ~= 0 or minutes ~= 0 or seconds ~= 0) then
		timeText = timeText..format("%d"..BM_SECONDS, seconds);
	else
		timeText = "--:--:--";
	end
	return timeText;
end
 --Hook
function BM_BuffFrame_Enchant_OnUpdate(elapsed)
	local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo();
	-- No enchants, kick out early
	if ( not hasMainHandEnchant and not hasOffHandEnchant ) then
		TempEnchant1:Hide();
		TempEnchant1Duration:Hide();
		TempEnchant2:Hide();
		TempEnchant2Duration:Hide();
		BuffFrame:SetPoint("TOPRIGHT", "TemporaryEnchantFrame", "TOPRIGHT", 0, 0);
		--BuffFrame:SetPoint("TOPRIGHT", "UIParent", "TOPRIGHT", -205, BM_UNIT_BUFF_FRAMES_Y);
		return;
	end
	-- Has enchants
	local enchantButton;
	local textureName;
	local buffAlphaValue;
	local enchantIndex = 0;
	if ( hasOffHandEnchant ) then
		enchantIndex = enchantIndex + 1;
		textureName = GetInventoryItemTexture("player", 17);
		TempEnchant1:SetID(17);
		TempEnchant1Icon:SetTexture(textureName);
		TempEnchant1:Show();
		hasEnchant = 1;

		-- Show buff durations if necessary
		if ( offHandExpiration ) then
			offHandExpiration = offHandExpiration/1000;
		end
		BuffFrame_UpdateDuration(TempEnchant1, offHandExpiration);

		-- Handle flashing
		if ( offHandExpiration and offHandExpiration < BUFF_WARNING_TIME ) then
			TempEnchant1:SetAlpha(BUFF_ALPHA_VALUE);
		else
			TempEnchant1:SetAlpha(1.0);
		end
		
	end
	if ( hasMainHandEnchant ) then
		enchantIndex = enchantIndex + 1;
		enchantButton = getglobal("TempEnchant"..enchantIndex);
		textureName = GetInventoryItemTexture("player", 16);
		enchantButton:SetID(16);
		getglobal(enchantButton:GetName().."Icon"):SetTexture(textureName);
		enchantButton:Show();
		hasEnchant = 1;

		-- Show buff durations if necessary
		if ( mainHandExpiration ) then
			mainHandExpiration = mainHandExpiration/1000;
		end
		
		BuffFrame_UpdateDuration(enchantButton, mainHandExpiration);

		-- Handle flashing
		if ( mainHandExpiration and mainHandExpiration < BUFF_WARNING_TIME ) then
			enchantButton:SetAlpha(BUFF_ALPHA_VALUE);
		else
			enchantButton:SetAlpha(1.0);
		end
	end
	--Hide unused enchants
	for i=enchantIndex+1, 2 do
		getglobal("TempEnchant"..i):Hide();
		getglobal("TempEnchant"..i.."Duration"):Hide();
	end

	-- Position buff frame
	TemporaryEnchantFrame:SetWidth(enchantIndex * 32);
	BuffFrame:SetPoint("TOPRIGHT", "TemporaryEnchantFrame", "TOPLEFT", -5, 0);
	--BuffFrame:SetPoint("TOPRIGHT", "UIParent", "TOPRIGHT", -205, BM_UNIT_BUFF_FRAMES_Y);
end

--Hook
function BM_updateContainerFrameAnchors()
	local freeScreenHeight = GetScreenHeight() - 70;
	local index = 1;
	local column = 0;
	local container_width = 192;
	local container_spacing = 0;
	local visible_container_spacing = 3;
	local container_offsetY = 0;
	local container_offsetX = 0;
	if (MultiBarLeft:IsVisible()) then
		container_offsetX = -90;
	elseif (MultiBarRight:IsVisible() and not MultiBarLeft:IsVisible()) then
		container_offsetX = -45;
	else
		container_offsetX = 0;
	end
	if (MultiBarBottomRight:IsVisible() and BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert) then
		container_offsetY = BhaldieInfoBarBG1:GetHeight()+85;
	elseif (MultiBarBottomRight:IsVisible() and BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert == false) then
		container_offsetY = 115;
	elseif (not MultiBarBottomRight:IsVisible() and BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert) then
		container_offsetY = BhaldieInfoBarBG1:GetHeight()+50;
	else
		container_offsetY = 70;
	end
	while ContainerFrame1.bags[index] do
		local frame = getglobal(ContainerFrame1.bags[index]);
		-- freeScreenHeight determines when to start a new column of bags
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].infobar_invert == true) then
			if ( index == 1 ) then
				-- First bag
				frame:SetPoint("BOTTOMRIGHT", frame:GetParent():GetName(), "BOTTOMRIGHT", container_offsetX, container_offsetY);
			elseif ( freeScreenHeight < frame:GetHeight() ) then
				-- Start a new column
				column = column + 1;
				freeScreenHeight = UIParent:GetHeight() - container_offsetY;
				frame:SetPoint("BOTTOMRIGHT", frame:GetParent():GetName(), "BOTTOMRIGHT", -(column * container_width)+container_offsetX, container_offsetY);
			else
				-- Anchor to the previous bag
				frame:SetPoint("BOTTOMRIGHT", ContainerFrame1.bags[index - 1], "TOPRIGHT", 0, container_spacing);	
			end
		else
			if ( index == 1 ) then
				-- First bag
				frame:SetPoint("BOTTOMRIGHT", frame:GetParent():GetName(), "BOTTOMRIGHT", container_offsetX, container_offsetY);
			elseif ( freeScreenHeight < frame:GetHeight() ) then
				-- Start a new column
				column = column + 1;
				freeScreenHeight = UIParent:GetHeight() - container_offsetY;
				frame:SetPoint("BOTTOMRIGHT", frame:GetParent():GetName(), "BOTTOMRIGHT", -(column * container_width)+container_offsetX, container_offsetY);
			else
				-- Anchor to the previous bag
				frame:SetPoint("BOTTOMRIGHT", ContainerFrame1.bags[index - 1], "TOPRIGHT", 0, container_spacing);	
			end
		end
		freeScreenHeight = freeScreenHeight - frame:GetHeight() - visible_container_spacing;
		--bib_debug(freeScreenHeight .. " ::: " .. frame:GetHeight());
		index = index + 1;
	end
end

--[[Hook
function BM_PetActionBarFrame_OnUpdate(elapsed)
	local yPos;
	local yPosFinish;
	if ( this.slideTimer and (this.slideTimer < this.timeToSlide) ) then
		this.completed = nil;
		if ( this.mode == "show" ) then
			if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].mainmenu_xp) then
				if (MultiBarBottomLeft.isShowing) then
					yPos = 128;
				else
					yPos = 86;
				end
			else
				if (MultiBarBottomLeft.isShowing) then
					yPosFinish = 141;
				else
					yPosFinish = 98;
				end
			end
			this:SetPoint("TOPLEFT", this:GetParent(), "BOTTOMLEFT", PETACTIONBAR_XPOS, yPos);
			this.state = "showing";
			this:Show();
		elseif ( this.mode == "hide" ) then
			if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].mainmenu_xp) then
				if (MultiBarBottomLeft.isShowing) then
					yPos = 128;
				else
					yPos = 86;
				end
			else
				if (MultiBarBottomLeft.isShowing) then
					yPosFinish = 141;
				else
					yPosFinish = 98;
				end
			end
			this:SetPoint("TOPLEFT", this:GetParent(), "BOTTOMLEFT", PETACTIONBAR_XPOS, yPos);
			this.state = "hiding";
		end
		this.slideTimer = this.slideTimer + elapsed;
		
	else
		this.completed = 1;
		if ( this.mode == "show" ) then
			if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].mainmenu_xp) then
				if (MultiBarBottomLeft.isShowing) then
					yPosFinish = 128;
				else
					yPosFinish = 86;
				end
			else
				if (MultiBarBottomLeft.isShowing) then
					yPosFinish = 141;
				else
					yPosFinish = 98;
				end
			end
			this:SetPoint("TOPLEFT", this:GetParent(), "BOTTOMLEFT", PETACTIONBAR_XPOS, yPosFinish);
			this.state = "top";
			--Move the chat frame and edit box up a bit
			FCF_UpdateDockPosition();
			--Move the casting bar up
			CastingBarFrame_UpdatePosition();
		elseif ( this.mode == "hide" ) then
			this:SetPoint("TOPLEFT", this:GetParent(), "BOTTOMLEFT", PETACTIONBAR_XPOS, 0);
			this.state = "bottom";
			this:Hide();
			--Move the chat frame and edit box back down to original position
			FCF_UpdateDockPosition();
			--Move the casting bar back down
			CastingBarFrame_UpdatePosition();
		end
		this.mode = "none";
	end
end

function BM_PetActionBar_UpdatePosition()
	local multibar_ypos = 0;
	if ( MultiBarBottomLeft.isShowing ) then
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].mainmenu_xp) then
			PETACTIONBAR_YPOS = 128;
			multibar_ypos = 4;
			SlidingActionBarTexture0:Hide();
			SlidingActionBarTexture1:Hide();
		else
			PETACTIONBAR_YPOS = 141;
			multibar_ypos = 17;
			SlidingActionBarTexture0:Hide();
			SlidingActionBarTexture1:Hide();
		end
	else
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].mainmenu_xp) then
			PETACTIONBAR_YPOS = 86;
			multibar_ypos = 4;
			SlidingActionBarTexture0:Show();
			SlidingActionBarTexture1:Show();
		else
			PETACTIONBAR_YPOS = 98;
			multibar_ypos = 17;
			SlidingActionBarTexture0:Show();
			SlidingActionBarTexture1:Show();
		end
	end
	if ( not PetActionBarFrame:IsShown() ) then
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].mainmenu_xp) then
			PETACTIONBAR_YPOS = 86;
			multibar_ypos = 4;
			SlidingActionBarTexture0:Show();
			SlidingActionBarTexture1:Show();
		else
			PETACTIONBAR_YPOS = 98;
			multibar_ypos = 17;
			SlidingActionBarTexture0:Show();
			SlidingActionBarTexture1:Show();
		end;
	end
	PetActionBarFrame:SetPoint("TOPLEFT", "MainMenuBar", "BOTTOMLEFT", PETACTIONBAR_XPOS, PETACTIONBAR_YPOS);
	MultiBarBottomLeft:SetPoint("BOTTOMLEFT", "ActionButton1", "TOPLEFT", 0, multibar_ypos);
end

function BM_ShapeshiftBar_UpdatePosition()
	if ( MultiBarBottomLeft.isShowing ) then
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].mainmenu_xp) then
			ShapeshiftBarFrame:SetPoint("BOTTOMLEFT", "MainMenuBar", "TOPLEFT", 30, 32);
			ShapeshiftBarLeft:Hide();
			ShapeshiftBarRight:Hide();
			ShapeshiftBarMiddle:Hide();
			for i=1, GetNumShapeshiftForms() do
				getglobal("ShapeshiftButton"..i.."NormalTexture"):SetWidth(50);
				getglobal("ShapeshiftButton"..i.."NormalTexture"):SetHeight(50);
			end
		else
			ShapeshiftBarFrame:SetPoint("BOTTOMLEFT", "MainMenuBar", "TOPLEFT", 30, 45);
			ShapeshiftBarLeft:Hide();
			ShapeshiftBarRight:Hide();
			ShapeshiftBarMiddle:Hide();
			for i=1, GetNumShapeshiftForms() do
				getglobal("ShapeshiftButton"..i.."NormalTexture"):SetWidth(50);
				getglobal("ShapeshiftButton"..i.."NormalTexture"):SetHeight(50);
			end
		end
	else
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].mainmenu_xp) then
			ShapeshiftBarFrame:SetPoint("BOTTOMLEFT", "MainMenuBar", "TOPLEFT", 30, -13);
			if ( GetNumShapeshiftForms() > 2 ) then
				ShapeshiftBarMiddle:Show();
			end
			ShapeshiftBarLeft:Show();
			ShapeshiftBarRight:Show();
			for i=1, GetNumShapeshiftForms() do
				getglobal("ShapeshiftButton"..i.."NormalTexture"):SetWidth(64);
				getglobal("ShapeshiftButton"..i.."NormalTexture"):SetHeight(64);
			end
		else
			ShapeshiftBarFrame:SetPoint("BOTTOMLEFT", "MainMenuBar", "TOPLEFT", 30, 0);
			if ( GetNumShapeshiftForms() > 2 ) then
				ShapeshiftBarMiddle:Show();
			end
			ShapeshiftBarLeft:Show();
			ShapeshiftBarRight:Show();
			for i=1, GetNumShapeshiftForms() do
				getglobal("ShapeshiftButton"..i.."NormalTexture"):SetWidth(64);
				getglobal("ShapeshiftButton"..i.."NormalTexture"):SetHeight(64);
			end
		end
	end
end


function BIB_CheckXPBar()
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM].mainmenu_xp) then
		MainMenuBarTexture0:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\UI-MainMenuBar-NoXP");
		MainMenuBarTexture0:SetTexCoord(0, 1.0, 0.79296875, 1.0);
		MainMenuBarTexture1:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\UI-MainMenuBar-NoXP");
		MainMenuBarTexture1:SetTexCoord(0, 1.0, 0.54296875, 0.75);
		MainMenuBarTexture2:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\UI-MainMenuBar-NoXP");
		MainMenuBarTexture2:SetTexCoord(0, 1.0, 0.29296875, 0.5);
		MainMenuBarTexture3:SetTexture("Interface\\Addons\\BhaldieInfoBar\\Images\\UI-MainMenuBar-NoXP");
		MainMenuBarTexture3:SetTexCoord(0, 1.0, 0.04296875, 0.25);
		MainMenuExpBar:SetWidth(0.0001);
		MainMenuBarPerformanceBarFrame:ClearAllPoints();
		MainMenuBarPerformanceBarFrame:SetPoint("BOTTOMRIGHT", "MainMenuBar", "BOTTOMRIGHT", -227, -10);
		MainMenuBarPerformanceBarFrame:ClearAllPoints();
		MainMenuBarPerformanceBarFrame:SetPoint("BOTTOMRIGHT", "MainMenuBar", "BOTTOMRIGHT", -227, -10);
	else
		MainMenuBarTexture0:SetTexture("Interface\\MainMenuBar\\UI-MainMenuBar-Dwarf");
		MainMenuBarTexture0:SetTexCoord(0, 1.0, 0.79296875, 1.0);
		MainMenuBarTexture1:SetTexture("Interface\\MainMenuBar\\UI-MainMenuBar-Dwarf");
		MainMenuBarTexture1:SetTexCoord(0, 1.0, 0.54296875, 0.75);
		MainMenuBarTexture2:SetTexture("Interface\\MainMenuBar\\UI-MainMenuBar-Dwarf");
		MainMenuBarTexture2:SetTexCoord(0, 1.0, 0.29296875, 0.5);
		MainMenuBarTexture3:SetTexture("Interface\\MainMenuBar\\UI-MainMenuBar-Dwarf");
		MainMenuBarTexture3:SetTexCoord(0, 1.0, 0.04296875, 0.25);
		MainMenuExpBar:SetWidth(1024);
		MainMenuBarPerformanceBarFrame:ClearAllPoints();
		MainMenuBarPerformanceBarFrame:SetPoint("BOTTOMRIGHT", "MainMenuExpBar", "BOTTOMRIGHT", -227, -50);
	end
	BM_PetActionBar_UpdatePosition();
	BM_ShapeshiftBar_UpdatePosition();
end]]

--This function is in every plugin always the same except for the 2 varables
function  BIB_Plugin_OnEnter()
	--if (this.registry ~= nil and getglobal(this:GetName() .. "_GetTooltipText")) then
	if (this.registry ~= nil and getglobal(this.registry.tooltipTextFunction)) then
		GameTooltip:SetOwner(this, "ANCHOR_NONE");
		GameTooltip:SetPoint(BM_TOOLTIP_ANCHOR .. BM_PositonToolTip_RightLeft(), this, BM_TOOLTIP_RELPOINT .. BM_PositonToolTip_RightLeft(), 0, 0);
		-- set the tool tip text 
		--only these two lines will change everything else is the same for all plugins
		GameTooltip:SetText(TitanUtils_GetGreenText(this.registry.menuText)); -- Usually found in localization file  TITAN_COMBATINFO_TOOLTIP="Combat Info"
		--BM_Tooltip_AddTooltipText(getglobal(this:GetName() .. "_GetTooltipText")()); --The variable created by the GetTooltipText() function
		BM_Tooltip_AddTooltipText(getglobal(this.registry.tooltipTextFunction)()); --The variable created by the GetTooltipText() function
		GameTooltip:Show();
	end
end

--This function is in every plugin always the same
function BIB_Plugin_OnLeave()
	-- put the tool tip in the default position
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
	GameTooltip:Hide();
end

--This function is in every plugin always the same
function BiB_Plugin_OnRightClick(button)
	if (button == "RightButton") then
		ToggleDropDownMenu(1, nil, getglobal(this:GetName().."RightClickMenu"), this:GetName(), 0, 0);
		GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
		GameTooltip:Hide();
	end
end

function BIB_OnUpdate(elapsed)
	local timeLeft = this.timer - elapsed;
	if (timeLeft <= 0) then
		this.timer = this.registry.frequency;
		TitanPanelButton_UpdateButton(this.registry.id)
	else
		this.timer = timeLeft;
	end
end

--------------------------------- Titan Functions ------------------------------------------
function TitanUtils_Ternary(a, b, c)
	if (a) then
		return b;
	else
		return c;
	end
end

function TitanUtils_GetColoredText(text, color)
	if (text and color) then
		local redColorCode = format("%02x", color.r * 255);		
		local greenColorCode = format("%02x", color.g * 255);
		local blueColorCode = format("%02x", color.b * 255);		
		local colorCode = "|cff"..redColorCode..greenColorCode..blueColorCode;
		return colorCode..text..FONT_COLOR_CODE_CLOSE;
	end
end

function TitanUtils_GetRedText(text)
	if (text) then
		return RED_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE;
	end
end

function TitanUtils_GetGreenText(text)
	if (text) then
		return GREEN_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE;
	end
end

function TitanUtils_GetNormalText(text)
	if (text) then
		return NORMAL_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE;
	end
end

function TitanUtils_GetHighlightText(text)
	if (text) then
		return HIGHLIGHT_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE;
	end
end

function TitanUtils_GetGrayText(text)
	if (text) then
		return GRAY_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE;
	end
end

function TitanUtils_GetLightYellowText(text)
	if (text) then
		return LIGHTYELLOW_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE;
	end
end

function BM_Initialize_Variables(id, name, value)
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][id..name] == nil) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][id..name] = value;
	end
end

function TitanGetVar(id, name)
	return BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][id..name];
end

function TitanPanelRightClickMenu_AddCommand(text, value, functionName, level)
	local info = {};
	info.text = text;
	info.value = value;
	info.func = getglobal(functionName);
	--info.notCheckable = 1;
	UIDropDownMenu_AddButton(info, level);
end

function TitanPanelRightClickMenu_AddToggleVar(text, id, var, toggleTable)
	local info = {};
	info.text = text;
	info.value = id..var;
	info.func = BM_Toggle_Option;
	info.checked = TitanGetVar(id, var);
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);
end

function TitanPanelRightClickMenu_AddSpacer(level)
	local info = {};
	info.disabled = 1;
	UIDropDownMenu_AddButton(info, level);
end

function TitanPanelRightClickMenu_AddTitle(title, level)
	if (title) then
		local info = {};
		info.text = title;
		info.notClickable = 1;
		info.isTitle = 1;
		UIDropDownMenu_AddButton(info, level);
	end
end

function BM_ToggleValue(id, var)
	if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][id..var] == true) then
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][id..var] = false;
	else
		BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][id..var] = true;
	end
end

function TitanToggleVar(id, var)
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][id..var] = BM_ToggleVars(this.checked);
end

function BM_Toggle_Option()
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][this.value] = BM_ToggleVars(this.checked);
	for key, value in BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"] do
		if (getglobal(value.framename .. "_SetIcon")) then
			getglobal(value.framename .. "_SetIcon")();
		end
		if ( getglobal(value.framename .. "_GetButtonText")) then
			getglobal(value.framename .. "_GetButtonText")();
		end
		if (getglobal(value.framename .. "_GetTooltipText")) then
			getglobal(value.framename .. "_GetTooltipText")();
		end
		if (getglobal(value.framename .. "_GetToolTipText")) then
			getglobal(value.framename .. "_GetToolTipText")();
		end
		if (getglobal(value.framename).registry ~= nil) then
			BiB_Plugin_SetIcon(value.framename, getglobal(value.framename).registry.id, getglobal(value.framename).registry.icon, getglobal(value.framename).registry.iconWidth);
			TitanPanelButton_UpdateButton(getglobal(value.framename).registry.id)
		end		
	end
end

function BM_ToggleVars(value)
	if (value) then
		return false;
	else
		return true;
	end
end

function TitanSetVar(id, var, value)
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][id..var] = value;
end

function TitanPanelRightClickMenu_Close()
	DropDownList1:Hide();
end

function TitanPanelRightClickMenu_IsVisible()
	return DropDownList1:IsVisible();
end

function TitanPanelRightClickMenu_AddToggleIcon(id)
	TitanPanelRightClickMenu_AddToggleVar(BM_SHOW_ICON, id, "ShowIcon");
end

function TitanPanelRightClickMenu_AddToggleLabelText(id)
	TitanPanelRightClickMenu_AddToggleVar(BM_SHOW_LABEL, id, "ShowLabelText");
end

function TitanPanelRightClickMenu_AddToggleColoredText(id)
	TitanPanelRightClickMenu_AddToggleVar(BM_SHOW_COLORED_TEXT, id, "ShowColoredText");
end

function TitanUtils_Toggle(value)
	if (value == 1) then
		return nil;
	else
		return 1;
	end
end

function TitanPanelButton_UpdateButton(id)
	local button = "TitanPanel" .. id .. "Button";
	local buttonText = getglobal("TitanPanel" .. id .. "ButtonText");
	local buttonIcon = getglobal("TitanPanel" .. id .. "ButtonIcon");
	--local buttonFunction = 
	if (id) then
		buttonTextFunction = getglobal(button).registry.buttonTextFunction;
		if (buttonTextFunction) then
			--local label1, value1, label2, value2, label3, value3, label4, value4 = getglobal(button .. "_GetButtonText")();
			local label1, value1, label2, value2, label3, value3, label4, value4 = getglobal(buttonTextFunction)();
			local text = "";
			if ( label1 and not ( label2 or label3 or label4 or value1 or value2 or value3 or value4 ) ) then
				text = label1;
			elseif (TitanGetVar(id, "ShowLabelText")) then
				if (label1 or value1) then
					text = label1 .. value1;
					if (label2 or value2) then
						text = text .." " .. label2 .. value2;
						if (label3 or value3) then
							text = text .." " .. label3 .. value3;
							if (label4 or value4) then
								text = text .." " .. label4 .. value4;
							end
						end
					end
				end
			else
				if (value1) then
					text = value1;
					if (value2) then
						text = text .. " " .. value2;
						if (value3) then
							text = text .. " " .. value3;
							if (value4) then
								text = text .. " " .. value4;
							end
						end
					end
				end
			end
			buttonText:SetText(text);			
		end	
	end
	if (getglobal(button .. "Icon") or getglobal(button).registry.iconWidth ~= nil) then
		BiB_Plugin_SetIcon(button, getglobal(button).registry.id, getglobal(button).registry.icon, getglobal(button).registry.iconWidth);
	end
end

function TitanPanelButton_UpdateTooltip()
end

function TitanOptionSlider_TooltipText(text, value) 
	return text .. GREEN_FONT_COLOR_CODE .. value .. FONT_COLOR_CODE_CLOSE;
end

function TitanSetVarTable(id, var, count, string)
	BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][id..var][count] = string;
end

function TitanGetVarTable(id, var, count)
	return BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][BM_PLUGINVARS][id..var][count];
end
--------------------------------------------------------------------------------------------------

function BIB_LogoButton_OnRightClick(button)
	if (button == "RightButton") then
		BIB_VolumeControlFrame:ClearAllPoints();
		BIB_VolumeControlFrame:SetPoint(BM_TOOLTIP_ANCHOR .. BM_PositonToolTip_RightLeft(), "BhaldieInfoBarLogo", BM_TOOLTIP_RELPOINT .. BM_PositonToolTip_RightLeft(), 0, 0);
		BIB_VolumeControlFrame:Show();
	end
end

--(This Volume Control Menu orginally called Titan Volume2 was built by PattyPur and was so well done decided to use it)
function TitanPanelVolume2Button_OnEnter()
	-- Confirm master volume value
	TitanPanelMasterVolume2ControlSlider:SetValue(1 - GetCVar("MasterVolume"));
	TitanPanelAmbienceVolume2ControlSlider:SetValue(1 - GetCVar("AmbienceVolume"));
	TitanPanelSoundVolume2ControlSlider:SetValue(1 - GetCVar("SoundVolume"));
	TitanPanelMusicVolume2ControlSlider:SetValue(1 - GetCVar("MusicVolume"));
	reset_Master = GetCVar("MasterVolume");
	reset_Ambience = GetCVar("AmbienceVolume");
	reset_Sound = GetCVar("SoundVolume");
	reset_Music = GetCVar("MusicVolume");
	SetCVar("MasterVolume", 50);
	SetCVar("AmbienceVolume", 50);
	SetCVar("SoundVolume", 50);
	SetCVar("MusicVolume", 50);
	SetCVar("MasterVolume", 0);
	SetCVar("AmbienceVolume", 0);
	SetCVar("SoundVolume", 0);
	SetCVar("MusicVolume", 0);
	SetCVar("MasterVolume", reset_Master);
	SetCVar("AmbienceVolume", reset_Ambience);
	SetCVar("SoundVolume", reset_Sound);
	SetCVar("MusicVolume", reset_Music);
end

-- 'Master' 
function TitanPanelMasterVolume2ControlSlider_OnEnter()
	this.tooltipText = TitanOptionSlider_TooltipText(TITAN_VOLUME2_CONTROL_TOOLTIP, TitanPanelVolume2_GetVolumeText(GetCVar("MasterVolume")));
	GameTooltip:SetOwner(this, "ANCHOR_BOTTOMLEFT");
	GameTooltip:SetText(this.tooltipText, nil, nil, nil, nil, 1);
end

function TitanPanelMasterVolume2ControlSlider_OnLeave()
	this.tooltipText = nil;
	GameTooltip:Hide();
end

function TitanPanelMasterVolume2ControlSlider_OnShow()
        
	getglobal(this:GetName().."Text"):SetText(TitanPanelVolume2_GetVolumeText(GetCVar("MasterVolume")));
	getglobal(this:GetName().."High"):SetText(TITAN_VOLUME2_CONTROL_LOW);
	getglobal(this:GetName().."Low"):SetText(TITAN_VOLUME2_CONTROL_HIGH);
	this:SetMinMaxValues(0, 1);
	this:SetValueStep(0.01);
	this:SetValue(1 - GetCVar("MasterVolume"));
end

function TitanPanelMasterVolume2ControlSlider_OnValueChanged()
	SetCVar("MasterVolume", 1 - this:GetValue());
	getglobal(this:GetName().."Text"):SetText(TitanPanelVolume2_GetVolumeText(GetCVar("MasterVolume")));

	-- Update GameTooltip
	if (this.tooltipText) then
		this.tooltipText = TitanOptionSlider_TooltipText(TITAN_VOLUME2_CONTROL_TOOLTIP, TitanPanelVolume2_GetVolumeText(GetCVar("MasterVolume")));
		GameTooltip:SetText(this.tooltipText, nil, nil, nil, nil, 1);
	end
end
-- 'Music'
function TitanPanelMusicVolume2ControlSlider_OnEnter()
	this.tooltipText = TitanOptionSlider_TooltipText(TITAN_VOLUME2_CONTROL_TOOLTIP, TitanPanelVolume2_GetVolumeText(GetCVar("MusicVolume")));
	GameTooltip:SetOwner(this, "ANCHOR_BOTTOMLEFT");
	GameTooltip:SetText(this.tooltipText, nil, nil, nil, nil, 1);
end

function TitanPanelMusicVolume2ControlSlider_OnLeave()
	this.tooltipText = nil;
	GameTooltip:Hide();
end

function TitanPanelMusicVolume2ControlSlider_OnShow()
        
	getglobal(this:GetName().."Text"):SetText(TitanPanelVolume2_GetVolumeText(GetCVar("MusicVolume")));
	getglobal(this:GetName().."High"):SetText(TITAN_VOLUME2_CONTROL_LOW);
	getglobal(this:GetName().."Low"):SetText(TITAN_VOLUME2_CONTROL_HIGH);
	this:SetMinMaxValues(0, 1);
	this:SetValueStep(0.01);
	this:SetValue(1 - GetCVar("MusicVolume"));
end

function TitanPanelMusicVolume2ControlSlider_OnValueChanged()
	SetCVar("MusicVolume", 1 - this:GetValue());
	getglobal(this:GetName().."Text"):SetText(TitanPanelVolume2_GetVolumeText(GetCVar("MusicVolume")));
	
	-- Update GameTooltip
	if (this.tooltipText) then
		this.tooltipText = TitanOptionSlider_TooltipText(TITAN_VOLUME2_CONTROL_TOOLTIP, TitanPanelVolume2_GetVolumeText(GetCVar("MusicVolume")));
		GameTooltip:SetText(this.tooltipText, nil, nil, nil, nil, 1);
	end
end
-- 'Sound'
function TitanPanelSoundVolume2ControlSlider_OnEnter()
	this.tooltipText = TitanOptionSlider_TooltipText(TITAN_VOLUME2_CONTROL_TOOLTIP, TitanPanelVolume2_GetVolumeText(GetCVar("SoundVolume")));
	GameTooltip:SetOwner(this, "ANCHOR_BOTTOMLEFT");
	GameTooltip:SetText(this.tooltipText, nil, nil, nil, nil, 1);
end

function TitanPanelSoundVolume2ControlSlider_OnLeave()
	this.tooltipText = nil;
	GameTooltip:Hide();
end

function TitanPanelSoundVolume2ControlSlider_OnShow()
        
	getglobal(this:GetName().."Text"):SetText(TitanPanelVolume2_GetVolumeText(GetCVar("SoundVolume")));
	getglobal(this:GetName().."High"):SetText(TITAN_VOLUME2_CONTROL_LOW);
	getglobal(this:GetName().."Low"):SetText(TITAN_VOLUME2_CONTROL_HIGH);
	this:SetMinMaxValues(0, 1);
	this:SetValueStep(0.01);
	this:SetValue(1 - GetCVar("SoundVolume"));
end

function TitanPanelSoundVolume2ControlSlider_OnValueChanged()
	SetCVar("SoundVolume", 1 - this:GetValue());
	getglobal(this:GetName().."Text"):SetText(TitanPanelVolume2_GetVolumeText(GetCVar("SoundVolume")));
	
	-- Update GameTooltip
	if (this.tooltipText) then
		this.tooltipText = TitanOptionSlider_TooltipText(TITAN_VOLUME2_CONTROL_TOOLTIP, TitanPanelVolume2_GetVolumeText(GetCVar("SoundVolume")));
		GameTooltip:SetText(this.tooltipText, nil, nil, nil, nil, 1);
	end
end
-- 'Ambience'
function TitanPanelAmbienceVolume2ControlSlider_OnEnter()
	this.tooltipText = TitanOptionSlider_TooltipText(TITAN_VOLUME2_CONTROL_TOOLTIP, TitanPanelVolume2_GetVolumeText(GetCVar("AmbienceVolume")));
	GameTooltip:SetOwner(this, "ANCHOR_BOTTOMLEFT");
	GameTooltip:SetText(this.tooltipText, nil, nil, nil, nil, 1);
end

function TitanPanelAmbienceVolume2ControlSlider_OnLeave()
	this.tooltipText = nil;
	GameTooltip:Hide();
end

function TitanPanelAmbienceVolume2ControlSlider_OnShow()
        
	getglobal(this:GetName().."Text"):SetText(TitanPanelVolume2_GetVolumeText(GetCVar("AmbienceVolume")));
	getglobal(this:GetName().."High"):SetText(TITAN_VOLUME2_CONTROL_LOW);
	getglobal(this:GetName().."Low"):SetText(TITAN_VOLUME2_CONTROL_HIGH);
	this:SetMinMaxValues(0, 1);
	this:SetValueStep(0.01);
	this:SetValue(1 - GetCVar("AmbienceVolume"));
end

function TitanPanelAmbienceVolume2ControlSlider_OnValueChanged()
	SetCVar("AmbienceVolume", 1 - this:GetValue());
	getglobal(this:GetName().."Text"):SetText(TitanPanelVolume2_GetVolumeText(GetCVar("AmbienceVolume")));
	
	-- Update GameTooltip
	if (this.tooltipText) then
		this.tooltipText = TitanOptionSlider_TooltipText(TITAN_VOLUME2_CONTROL_TOOLTIP, TitanPanelVolume2_GetVolumeText(GetCVar("AmbienceVolume")));
		GameTooltip:SetText(this.tooltipText, nil, nil, nil, nil, 1);
	end
end
function TitanPanelVolume2_GetVolumeText(volume)
	return tostring(floor(100 * volume + 0.5)) .. "%";
end

function TitanPanelVolume2ControlFrame_OnLoad()
	getglobal(this:GetName().."Title"):SetText(TITAN_VOLUME2_CONTROL_TITLE);
	getglobal(this:GetName().."MasterTitle"):SetText(TITAN_VOLUME2_MASTER_CONTROL_TITLE);
	getglobal(this:GetName().."MusicTitle"):SetText(TITAN_VOLUME2_MUSIC_CONTROL_TITLE);
	getglobal(this:GetName().."SoundTitle"):SetText(TITAN_VOLUME2_SOUND_CONTROL_TITLE);
	getglobal(this:GetName().."AmbienceTitle"):SetText(TITAN_VOLUME2_AMBIENCE_CONTROL_TITLE);
	this:SetBackdropBorderColor(1, 1, 1);
	this:SetBackdropColor(0, 0, 0, 1);
end

function BIB_SaveButton_Pressed()
	local profileName = BIB_EditBox:GetText();
	if (profileName ~= nil) then
		if (BHINFOBAR_CONFIG["Profiles"][profileName] == nil) then
			BHINFOBAR_CONFIG["Profiles"][profileName] = {};
		end
		BIB_Copy_Table(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM], BHINFOBAR_CONFIG["Profiles"][profileName]);
	end
end

function BIB_LoadButton_Pressed()
	local profileName = BIB_ProfileDropDownText:GetText();
	local pluginCheck = false;
	if (profileName ~= nil) then
		if (table.getn(BHINFOBAR_CONFIG["Profiles"][profileName]["Plugins"]) > table.getn(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"])) then
			for keyprofile, valueprofile in BHINFOBAR_CONFIG["Profiles"][profileName]["Plugins"] do
				for keyplayer, valueplayer in BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"] do
					if (valueplayer.name == valueprofile.name) then
						pluginCheck = true;
						break;
					else
						pluginCheck = false;
					end
				end
				if (pluginCheck == false) then
					break;
				end
			end
		else
			for keyplayer, valueplayer in BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"] do
				for keyprofile, valueprofile in BHINFOBAR_CONFIG["Profiles"][profileName]["Plugins"] do
					if (valueplayer.name == valueprofile.name) then
						pluginCheck = true;
						break;
					else
						pluginCheck = false;
					end
				end
				if (pluginCheck == false) then
					break;
				end
			end
		end
		if (pluginCheck) then
			BIB_Copy_Table(BHINFOBAR_CONFIG["Profiles"][profileName], BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]);
			BM_XP_Info_Enable(BHINFOBAR_CONFIG["Profiles"][profileName].xp_info);
			BM_Infobar_HideXP(BHINFOBAR_CONFIG["Profiles"][profileName].infobar_hidexp);
			BM_Infobar_Invert(BHINFOBAR_CONFIG["Profiles"][profileName].infobar_invert);
			BM_XPBar_Scale(BHINFOBAR_CONFIG["Profiles"][profileName].infobar_xpscale);
			BM_Plugin_XSpace(BHINFOBAR_CONFIG["Profiles"][profileName].plugin_xspace);
			BM_Plugin_FontSize(BHINFOBAR_CONFIG["Profiles"][profileName].plugin_fontsize);
			BM_Infobar_HideLogo(BHINFOBAR_CONFIG["Profiles"][profileName].infobar_hidelogo);
			BM_Alpha_SlashHandler(BHINFOBAR_CONFIG["Profiles"][profileName].infobar_alpha);
			BM_Slider1:SetValue(BHINFOBAR_CONFIG["Profiles"][profileName].infobar_alpha);
			BIB_FontDropDown_OnLoad();
			BIB_ChangeFont(BHINFOBAR_CONFIG["Profiles"][profileName].fontCode, BHINFOBAR_CONFIG["Profiles"][profileName].plugin_fontsize)
			BhaldieInfoBar_Refresh();
			BhaldieInfoBarPlugins_Refresh();
			BIB_EditBox:SetText(profileName);
		else
			bib_debug("Can't Load Profile!!");
			StaticPopup_Show("BM_NO_PROFILE");
		end
		
	end
end

function BIB_DeleteButton_Pressed()
	local profileName = BIB_ProfileDropDownText:GetText();
	if (profileName ~= nil) then
		local temp_profiles = BHINFOBAR_CONFIG["Profiles"];
		BHINFOBAR_CONFIG["Profiles"] = {};
		for key, value in temp_profiles do
			if (profileName ~= key) then
				BHINFOBAR_CONFIG["Profiles"][key] = temp_profiles[key];
			end
		end
		BIB_EditBox:SetText("");
	end
end

function BIB_Copy_Table(src, dest)
	for index, value in src do
		if (type(value) == "table") then
			dest[index] = {};
			BIB_Copy_Table(value, dest[index]);
		else
			dest[index] = value;
		end
	end
end

StaticPopupDialogs["BM_NO_PROFILE"] = {
	text = TEXT(BM_NO_PROFILE_TEXT),
	button1 = TEXT(OKAY),
	timeout = 0,
	exclusive = 1
};

--*****Debug Mode*****--
function bib_debug(value)
	if (BHINFOBAR_CONFIG.bib_debug == "true") then
		DEFAULT_CHAT_FRAME:AddMessage(BM_YELLOW .. "Debug value: " .. BM_FONT_OFF .. BM_GREEN .. value .. BM_FONT_OFF);
	end
end
--*******************--