function BM_UI_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	-- Add BM_Frame to the UIPanelWindows list
	UIPanelWindows["BM_Frame"] = {area = "center", pushable = 0};
	BM_Frame_TitleText:SetTextColor(ITEM_QUALITY6_TOOLTIP_COLOR.r, ITEM_QUALITY6_TOOLTIP_COLOR.g, ITEM_QUALITY6_TOOLTIP_COLOR.b);
end

function BM_UI_OnEvent()
	if (event == "VARIABLES_LOADED") then
		BM_UI_Initialize();
	end
end

function BM_UI_Initialize()
	local table_count;
	if (BHALDIEINFOBAR_LOADED ~= nil) then
		table_count = table.getn(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"]);
		for i=1, table_count, 1 do
			BM_Plugin_CheckButtons[BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].name] = {
				id = i, 
				strVar = "enable",
				pSlashCommand = BM_Plugin_Enable;
			};
			getglobal("BM_Plugin_Check" .. i):Show();
			getglobal("BM_Plugin".. i .. "_Button"):Show();
			getglobal("BM_Plugin".. i .. "_Button"):SetText(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].name);
		end
	end
end

function BM_SideButton_OnClick()
	local menu_id = this:GetID();
	local menu_name = this:GetText();
	local table_count;
	if (BHALDIEINFOBAR_LOADED ~= nil) then
		table_count = table.getn(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"]);
	end
	BM_TitileText:SetText(menu_name);
	if (menu_id == 1 and BHALDIEMOVEIT_LOADED ~= nil) then
		BhaldieMoveIT_Window:Show();
		BhaldieInfobar_Window:Hide();
		BhaldieInfobarPlugins_Window:Hide();
		if (BHALDIEINFOBAR_LOADED ~= nil) then
			if (table_count > 0) then
				for i=1, table_count, 1 do
					getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].framename .. "Options"):Hide();
				end
			end
		end
		BhaldieMoveIT_Refresh();
	elseif (menu_id == 2 and BHALDIEINFOBAR_LOADED ~= nil) then
		BhaldieMoveIT_Window:Hide();
		BhaldieInfobar_Window:Show();
		BhaldieInfobarPlugins_Window:Hide();
		if (table_count > 0) then
			for i=1, table_count, 1 do
				getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].framename .. "Options"):Hide();
			end
		end
		BhaldieInfoBar_Refresh();
	elseif (menu_id == 3 and BHALDIEINFOBAR_LOADED ~= nil and table_count > 0) then
		BhaldieMoveIT_Window:Hide();
		BhaldieInfobar_Window:Hide();
		BhaldieInfobarPlugins_Window:Show();
		for i=1, table_count, 1 do
			getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].framename .. "Options"):Hide();
		end
		BhaldieInfoBarPlugins_Refresh();
	elseif (menu_id > 3 and BHALDIEINFOBAR_LOADED ~= nil) then
		BhaldieMoveIT_Window:Hide();
		BhaldieInfobar_Window:Hide();
		BhaldieInfobarPlugins_Window:Hide();
		for i=1,table_count, 1 do
			if (i == menu_id-3) then
				local temp;
				getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].framename .. "Options"):Show();
				if (getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].framename .. "_RefreshOptions")) then
					getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].framename .. "_RefreshOptions")();
				end
			else
				getglobal(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][i].framename .. "Options"):Hide();
			end
		end
	else
		BhaldieMoveIT_Window:Hide();
		BhaldieInfobar_Window:Hide();
		BhaldieInfobarPlugins_Window:Hide();
	end
end

--[[
function BM_Click_Show_UI()
	ShowUIPanel(BM_Frame);
end]]

function BM_LogoButton_OnClick()
	ShowUIPanel(BM_Frame);
end

-- Moveit Options
local BM_CheckButtons = { };
if (BHALDIEMOVEIT_LOADED ~= nil) then
	BM_CheckButtons[BM_ACTION_ENABLE] = {
		id = 1,
		strVar = "action_enable",
		pSlashCommand = BM_ActioinBar_Enable
	};
	BM_CheckButtons[BM_BAG_BAR_ENABLE] = {
		id = 2, 
		strVar = "bagbar_enable",
		pSlashCommand = BM_BagBar_Enable
	};
	BM_CheckButtons[BM_BAG_BAR_LOCK] = {
		id = 3, 
		strVar = "bagbar_lock",
		pSlashCommand = BM_BagBar_Lock
	};
	BM_CheckButtons[BM_MINI_BAR_ENABLE] = {
		id = 4, 
		strVar = "minibar_enable",
		pSlashCommand = BM_MiniBar_Enable
	};
	BM_CheckButtons[BM_MINI_BAR_LOCK] = {
		id = 5, 
		strVar = "minibar_lock",
		pSlashCommand = BM_MiniBar_Lock
	};
	BM_CheckButtons[BM_CAST_BAR_LOCK] = {
		id = 6, 
		strVar = "castbar_lock",
		pSlashCommand = BM_CastBar_Lock
	};
	BM_CheckButtons[BM_CAST_BAR_ENABLE] = {
		id = 14, 
		strVar = "castbar_enable",
		pSlashCommand = BM_CastBar_Enable
	};
	BM_CheckButtons[BM_PET_BAR_ENABLE] = {
		id = 7, 
		strVar = "petbar_enable",
		pSlashCommand = BM_PetBar_Enable
	};
	BM_CheckButtons[BM_PET_BAR_LOCK] = {
		id = 8, 
		strVar = "petbar_lock",
		pSlashCommand = BM_PetBar_Lock
	};
	BM_CheckButtons[BM_BONUS_BAR_LOCK] = {
		id = 9, 
		strVar = "shapeshift_lock",
		pSlashCommand = BM_BonusBar_Lock
	};
	BM_CheckButtons[BM_BONUS_BAR_ENABLE] = {
		id = 15, 
		strVar = "shapeshift_enable",
		pSlashCommand = BM_BonusBar_Enable
	};
	BM_CheckButtons[BM_BAGSTATUS_BAR_ENABLE] = {
		id = 10, 
		strVar = "bagstatus_enable",
		pSlashCommand = BM_BagStatus_Enable
	};
	BM_CheckButtons[BM_BAGSTATUS_BAR_LOCK] = {
		id = 11, 
		strVar = "bagstatus_lock",
		pSlashCommand = BM_BagStatus_Lock
	};
	BM_CheckButtons[BM_MAIL_FRAME_ENABLE] = {
		id = 13, 
		strVar = "mail_frame",
		pSlashCommand = BM_Mail_Frame_Enable
	};
end

--Infobar options
local BM_Infobar_CheckButtons = { };
local BM_Sliders = { };
if (BHALDIEINFOBAR_LOADED ~= nil) then
	--[[BM_Infobar_CheckButtons[BM_INFO_BAR_ENABLE] = {
		id = 1, 
		strVar = "infobar_enable",
		pSlashCommand = BM_InfoBar_Enable
	};]]
	BM_Infobar_CheckButtons[BM_XP_INFO_ENABLE] = {
		id = 1, 
		strVar = "xp_info",
		pSlashCommand = BM_XP_Info_Enable
	};
	BM_Infobar_CheckButtons[BM_INFOBAR_INVERT] = {
		id = 2, 
		strVar = "infobar_invert",
		pSlashCommand = BM_Infobar_Invert
	};
	BM_Infobar_CheckButtons[BM_INFOBAR_HIDEXP] = {
		id = 3, 
		strVar = "infobar_hidexp",
		pSlashCommand = BM_Infobar_HideXP
	};
	BM_Infobar_CheckButtons[BM_INFOBAR_HIDELOGO] = {
		id = 4, 
		strVar = "infobar_hidelogo",
		pSlashCommand = BM_Infobar_HideLogo
	};
	BM_Infobar_CheckButtons[BM_CENTER_PLUGINS] = {
		id = 5, 
		strVar = "center_plugins",
		pSlashCommand = BM_Center_Plugins
	};
	--[[
	BM_Infobar_CheckButtons["Disable Main Menu Bar XP"] = {
		id = 6, 
		strVar = "mainmenu_xp",
		pSlashCommand = BIB_ToogleMainMenuTexture
	};]]
	BM_Infobar_CheckButtons[BM_AUTO_HIDE] = {
		id = 7, 
		strVar = "autohide",
		pSlashCommand = BIB_ToogleAutoHide
	};
	BM_Infobar_CheckButtons[BM_SHOW_REPBAR] = {
		id = 8, 
		strVar = "showrepbar",
		pSlashCommand = BIB_ShowRepBar
	};
	BM_Sliders[BM_INFO_ALPHASLIDER] = {
		id = 1,
		strVar = "infobar_alpha",
		pSlashCommand = BM_Alpha_SlashHandler,
		minValue = 0.0,
		maxValue = 1.0,
		valueStep = .01,
		minText="0%",
		maxText="100%",
	};
	BM_Sliders[BM_INFO_XPBAR_SCALE] = {
		id = 2,
		strVar = "infobar_xpscale",
		pSlashCommand = BM_XPBar_Scale,
		minValue = -500,
		maxValue = 60,
		valueStep = 1,
		minText="500",
		maxText="60",
	};
	BM_Sliders[BM_PLUGIN_XSPACER] = {
		id = 3,
		strVar = "plugin_xspace",
		pSlashCommand = BM_Plugin_XSpace,
		minValue = -25,
		maxValue = 25,
		valueStep = 1,
		minText="-25",
		maxText="25",
	};
	BM_Sliders[BM_PLUGIN_FONTSIZE] = {
		id = 4,
		strVar = "plugin_fontsize",
		pSlashCommand = BM_Plugin_FontSize,
		minValue = 1,
		maxValue = 30,
		valueStep = 1,
		minText="1",
		maxText="30",
	};
end

function BhaldieInfoBar_Refresh()
	-- Initial Values
	local button, string, checked;
	-- Setup check buttons
	for key, value in BM_Infobar_CheckButtons do
		button = getglobal("BM_Infobar_Check" .. value.id);
		string = getglobal("BM_Infobar_Check" .. value.id .. "Text");
		checked = nil;
		button.disabled = nil;
		--Check Box
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][value.strVar] == true) then
			checked = 1;
		else
			checked = 0;
		end
		--DEFAULT_CHAT_FRAME:AddMessage("Item Checked: " .. button);
		button:SetChecked(checked);
		string:SetText(key);
		button.pSlashCommand = value.pSlashCommand;
	end

	local slider, string, low, high;
	-- Setup Sliders
	for key, value in BM_Sliders do
		slider = getglobal("BM_Slider"..value.id);
		string = getglobal("BM_Slider"..value.id.."Text");
		low = getglobal("BM_Slider"..value.id.."Low");
		high = getglobal("BM_Slider"..value.id.."High");
		
		slider.id = value.id;
		slider.strVar = value.strVar;
		slider.pSlashCommand = value.pSlashCommand;
		
		--OptionsFrame_EnableSlider(slider);
		slider:SetMinMaxValues(value.minValue, value.maxValue);
		slider:SetValueStep(value.valueStep);
		slider:SetValue(BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM][value.strVar]);
		string:SetText(key);
		low:SetText(value.minText);
		high:SetText(value.maxText);
	end
end

--Called when option page loads
function BhaldieInfoBarPlugins_Refresh()
	-- Initial Values
	local button, string, checked;
	-- Setup check buttons
	for key, value in BM_Plugin_CheckButtons do
		button = getglobal("BM_Plugin_Check" .. value.id);
		string = getglobal("BM_Plugin_Check" .. value.id .. "Text");
		checked = nil;
		button.disabled = nil;
		--Check Box
		if (BHINFOBAR_CONFIG[BM_PLAYERNAME_REALM]["Plugins"][value.id][value.strVar] == true) then
			checked = 1;
		else
			checked = 0;
		end
		--DEFAULT_CHAT_FRAME:AddMessage("Item Checked: " .. button);
		button:SetChecked(checked);
		string:SetText(key);
		button.pSlashCommand = value.pSlashCommand;
	end
end
--Called when option page loads
function BhaldieMoveIT_Refresh()
	-- Initial Values
	local button, string, checked;
	-- Setup check buttons
	local table_name;
	for key, value in BM_CheckButtons do
		button = getglobal("BM_Check" .. value.id);
		string = getglobal("BM_Check" .. value.id .. "Text");
		checked = nil;
		button.disabled = nil;
		--Check Box
		if (BM_CONFIG[BM_PLAYERNAME_REALM][value.strVar] == true) then
			checked = 1;
		else
			checked = 0;
		end
		--DEFAULT_CHAT_FRAME:AddMessage("Item Checked: " .. value);
		button:SetChecked(checked);
		string:SetText(key);
		button.pSlashCommand = value.pSlashCommand;
	end
end

function BM_CheckButton_OnClick()
	local	bChecked;
	if (this:GetChecked()) then
		bChecked = true;
	else
		bChecked = false;
	end
	this.pSlashCommand(bChecked,this:GetID());
end

function BM_Slider_OnValueChanged(this)
	this.pSlashCommand(this:GetValue());
	
	-- set the tool tip text
	if (this:GetValue() == floor(this:GetValue())) then
		GameTooltip:SetText(format("%d", this:GetValue()));
	else
		GameTooltip:SetText(format("%.2f", this:GetValue()));
	end
end

function BM_Slider_OnEnter(this)
	-- put the tool tip in the default position
	GameTooltip:SetOwner(this, "ANCHOR_CURSOR");
	
	-- set the tool tip text
	if (this:GetValue() == floor(this:GetValue())) then
		GameTooltip:SetText(format("%d", this:GetValue()));
	else
		GameTooltip:SetText(format("%.2f", this:GetValue()));
	end
	
	GameTooltip:Show();
end

function BM_Slider_OnLeave(this)
	GameTooltip:Hide();
end